#version 140

            float ambient = 0.1;
            uniform float wateramount = 0.0;
            
			float landBlendPercent = 20; //Rename -> decides how high water gets blended over land
            float grassLevelEnd = 55;
            float sgBlend = 85;        
            
            in float height;
            in vec3 normal;
           
            uniform float maxHeight;
            uniform vec3 lightDir;
            uniform sampler2D GrassTex;
            uniform sampler2D SnowTex;
            uniform sampler2D WaterTex;
            in vec2 tex_coord;
            uniform int waterOn = 0;
            
           
		   vec4 blendTerrain(vec4 tex1, vec4 tex2, float th1, float th2)
		   {
					//Alpha Blending
					float lBlend = 1/(th2 - th1) * (height - th1);
                    vec4 fragColor = mix(tex1,tex2,lBlend);
                    return fragColor;
		   }

            void main(void)
            {
                float diffuse = clamp(dot(lightDir, normalize(normal)), 0.0, 1.0);
                
                float heightPerPercent = (maxHeight)/100;

                float waterHeight = wateramount * heightPerPercent;
                float landHeight = landBlendPercent * heightPerPercent;
                float grassLevelEnd = heightPerPercent  *  grassLevelEnd;
                float mountainHeight = heightPerPercent * sgBlend;
                
				vec4 fragColor;

                if (waterOn == 1)
                {
                    if( height <= waterHeight)
						fragColor = texture2D(WaterTex, tex_coord.st);
					else if (waterHeight + landHeight <= grassLevelEnd )
					{
						if( height <= landHeight + waterHeight )
								fragColor =  blendTerrain(texture2D(WaterTex, tex_coord.st),texture2D(GrassTex, tex_coord.st),waterHeight,landHeight+waterHeight);
						else if(height <= grassLevelEnd )
							    fragColor = texture2D(GrassTex, tex_coord.st);
						else if(height <= mountainHeight)
								fragColor = blendTerrain(texture2D(GrassTex, tex_coord.st),texture2D(SnowTex, tex_coord.st),grassLevelEnd, mountainHeight);
						else
								 fragColor = texture2D(SnowTex, tex_coord.st);
					}
					else if (waterHeight + landHeight <= mountainHeight)
					{
						if( height <=  (mountainHeight- grassLevelEnd) + waterHeight)
								 fragColor = blendTerrain(texture2D(WaterTex, tex_coord.st),texture2D(SnowTex, tex_coord.st),waterHeight, (mountainHeight- grassLevelEnd) + waterHeight);
						else
								 fragColor = texture2D(SnowTex, tex_coord.st);
					}
					else
								fragColor = blendTerrain(texture2D(WaterTex, tex_coord.st),texture2D(SnowTex, tex_coord.st),waterHeight, maxHeight);

                }
				else
				{
						if(height <= grassLevelEnd )
								fragColor = texture2D(GrassTex, tex_coord.st);
						else if(height <= mountainHeight)
								fragColor = blendTerrain(texture2D(GrassTex, tex_coord.st),texture2D(SnowTex, tex_coord.st),grassLevelEnd, mountainHeight);
						else
								fragColor = texture2D(SnowTex, tex_coord.st);
				}

				gl_FragColor  = fragColor * diffuse + fragColor * ambient;
               
                
            }